#include <STC8H.h>
#include <intrins.h>
#include "Delayms.h"

float ADCRes = 0.00;

void ADC_Init()
{
	ADCTIM = 0x3f;
	ADCCFG = 0x27;
	ADC_CONTR = 0x88;
	Delayms(1);
}

float ADC_GetVoltage(unsigned int i)
{
	if(i == 0) //صѹ
	{
		ADC_CONTR = 0x88;
		ADC_CONTR |= 0x40;
		_nop_();
		_nop_();
		while (!(ADC_CONTR & 0x20));
		ADC_CONTR &= ~0x20;
		ADCRes = (ADC_RES << 8) | ADC_RESL;
		ADCRes *= 0.0048828;
	}
	
	else if(i == 1) //USBѹ
	{
		ADC_CONTR = 0x89;
		ADC_CONTR |= 0x40;
		_nop_();
		_nop_();
		while (!(ADC_CONTR & 0x20));
		ADC_CONTR &= ~0x20;
		ADCRes = (ADC_RES << 8) | ADC_RESL;
		ADCRes *= 0.0048828;
	}
	
	else if(i == 2) //12Vѹ
	{
		ADC_CONTR = 0x8A;
		ADC_CONTR |= 0x40;
		_nop_();
		_nop_();
		while (!(ADC_CONTR & 0x20));
		ADC_CONTR &= ~0x20;
		ADCRes = (ADC_RES << 8) | ADC_RESL;
		ADCRes *= 0.0048828;
	}
	
	else
	{
		ADCRes = 0.00;
	}
	
	return ADCRes;
}