//@12.000MHz

#include <STC8H.h>
#include <intrins.h>
#include "Delayms.h"
#include "ADC.h"
#include "PPM.h"

//״̬ж
bit sta_chg = 0; //״̬
bit sta_on = 0; //ź״̬
bit sta_batavail = 0; //صѹ
bit sta_12Vavail = 0; //12V
bit sta_USBavail = 0; //USB
bit sta_lowbat = 0; //Ƿѹ
//һ״̬ж
bit prevsta_chg = 0; //״̬
bit prevsta_on = 0; //ź״̬
bit prevsta_batavail = 0; //صѹ
bit prevsta_12Vavail = 0; //12V
bit prevsta_USBavail = 0; //USB
bit prevsta_lowbat = 0; //Ƿѹ
//״̬ж-ͨI2C⴫
unsigned int status = 0x00;

bit isda = 1; //I2C-豸ַ־
bit isma = 1; //I2C-洢ַ־
unsigned int addr = 0x00; //I2C-дݵַ

void GPIO_Init()
{
	P0M0 &= ~0x07; P0M1 |= 0x07;
  P1M0 |= 0xc7; P1M1 &= ~0xc7;
  P2M0 = 0x3b; P2M1 = 0xfc;
  P3M0 |= 0x18; P3M1 &= ~0x18;
}

void I2C_Init()
{
	I2CCFG = 0x01;
	I2CSLADR = 0xD0; //豸ַ0x68
	I2CSLST = 0x00;
	I2CSLCR = 0x78;
	EA = 1;
}

void InformHost() {P23 = 0;}

void I2C_Isr() interrupt 24
{
	_push_(P_SW2);
	
	if(I2CSLST & 0x40) {I2CSLST &= ~0x40; isda = 1; isma = 1;}
	else if(I2CSLST & 0x20)
	{
		I2CSLST &= ~0x20;
		if(isda) {isda = 0; P23 = 1;}
		else if(isma)
		{
			isma = 0;
			addr = I2CRXD;
			if(addr == 0x01) {I2CTXD = status;}
			else {I2CTXD = 0xff;}
		}
		else
		{
			if(addr == 0x02)
			{
				if(I2CRXD == 0x00) {PPM_USBOUTSW(0);}
				else {PPM_USBOUTSW(1);}
			}
		}
	}
	else if(I2CSLST & 0x10)
	{
		I2CSLST &= ~0x10;
		if(I2CSLST & 0x02) {I2CTXD = 0xff;}
		else {I2CTXD = status;}
	}
	else if(I2CSLST & 0x08) {I2CSLST &= ~0x08; isda = 1; isma = 1;}
	
	_pop_(P_SW2);
}

void main()
{
	GPIO_Init();
	P_SW2 = 0x90; //лI2C˿ڵP2.4P2.5ʹܷXFR
	ADC_Init();
	I2C_Init();
	P23 = 1;
	
	while(1)
	{
		//״̬ж
		//سжָʾƿ
		if(P26 == 0) {P33 = 1;} else {P33 = 0;}
		if(P27 == 0) {P34 = 1;} else {P34 = 0;}
		if((P26 == 0) && (P27 == 1)) {sta_chg = 1;} else {sta_chg = 0;}
		//ѹж
		if(ADC_GetVoltage(0) < 10.8) {sta_batavail = 0;}
		if(ADC_GetVoltage(0) < 9.6) {sta_lowbat = 1;} else {sta_lowbat = 0;}
		if(ADC_GetVoltage(0) >= 11.1) {sta_batavail = 1;}
		if(ADC_GetVoltage(2) < 10.8) {sta_12Vavail = 0;}
		if(ADC_GetVoltage(2) >= 11.5) {sta_12Vavail = 1;}
		if(ADC_GetVoltage(1) < 4.4) {sta_USBavail = 0;}
		if(ADC_GetVoltage(1) >= 4.8) {sta_USBavail = 1;}
		//ػź״̬ж
		if((P22 == 1) && ((sta_batavail == 1) || (sta_12Vavail == 1) || (sta_USBavail == 1))) {sta_on = 1;}
		if(P22 == 0) {sta_on = 0;}
		
		//¼
		//12V
		if((prevsta_12Vavail == 0) && (sta_12Vavail == 1))
		{
			PPM_5VSW(2);
			if(sta_on == 1) {PPM_3V3SW(1); InformHost();}
			PPM_CHGSW(1);
		}
		if((prevsta_12Vavail == 1) && (sta_12Vavail == 0))
		{
			if(sta_USBavail == 1;)
			{
				if(sta_on == 1) {PPM_3V3SW(2); InformHost();}
				PPM_CHGSW(2);
				PPM_5VSW(0);
			}
			else
			{
				if(sta_on == 1) {PPM_5VSW(1); PPM_3V3SW(1); InformHost();}
				else {PPM_5VSW(0);}
				PPM_CHGSW(0);
			}
		}
		//USB
		if((prevsta_USBavail == 0) && (sta_USBavail == 1) && (sta_12Vavail == 0))
		{
			if(sta_on == 1) {PPM_3V3SW(2); InformHost();}
			PPM_5VSW(0);
			PPM_CHGSW(2);
		}
		if((prevsta_USBavail == 1) && (sta_USBavail == 0) && (sta_12Vavail == 0))
		{
			if(sta_on == 1) {PPM_5VSW(1); PPM_3V3SW(1); InformHost();}
			PPM_CHGSW(0);
		}
		//ػл
		if((prevsta_on == 0) && (sta_on == 1))
		{
			if(sta_12Vavail == 1) {PPM_5VSW(2); PPM_3V3SW(1);}
			else if(sta_USBavail == 1) {PPM_3V3SW(2);}
			else {PPM_5VSW(1); PPM_3V3SW(1);}
			I2CCFG = 0x81;
		}
		if((prevsta_on == 1) && (sta_on == 0))
		{
			I2CCFG = 0x01;
			PPM_USBOUTSW(0);
			if(sta_12Vavail == 0) {PPM_5VSW(0);}
			PPM_3V3SW(0);
		}
		//
		if((prevsta_chg == 0) && (sta_chg == 1) && (sta_on == 1)) {InformHost();}
		if((prevsta_chg == 1) && (sta_chg == 0) && (sta_on == 1)) {InformHost();}
		//Ƿѹ
		if((prevsta_batavail == 1) && (sta_batavail == 0)) {InformHost();}
		if((prevsta_lowbat == 0) && (sta_lowbat == 1)) {sta_on = 0; I2CCFG = 0x01; PPM_USBOUTSW(0); PPM_3V3SW(0); PPM_5VSW(0);}
		
		//¼ǰж
		prevsta_chg = sta_chg;
		prevsta_on = sta_on;
		prevsta_batavail = sta_batavail;
		prevsta_12Vavail = sta_12Vavail;
		prevsta_USBavail = sta_USBavail;
		prevsta_lowbat = sta_lowbat;
		status = (sta_chg << 3) | (sta_batavail << 2) | (sta_12Vavail << 1) | (sta_USBavail);
	}
}